diff --git a/dirsrvtests/tests/suites/gssapi_repl/gssapi_repl_test.py b/dirsrvtests/tests/suites/gssapi_repl/gssapi_repl_test.py
index 805dd89..ff3077c 100644
--- a/dirsrvtests/tests/suites/gssapi_repl/gssapi_repl_test.py
+++ b/dirsrvtests/tests/suites/gssapi_repl/gssapi_repl_test.py
@@ -1,3 +1,11 @@
+# --- BEGIN COPYRIGHT BLOCK ---
+# Copyright (C) 2016 Red Hat, Inc.
+# All rights reserved.
+#
+# License: GPL (version 3 or any later version).
+# See LICENSE for details.
+# --- END COPYRIGHT BLOCK ---
+#
 import os
 import sys
 import time
@@ -12,7 +20,6 @@ from lib389.tasks import *
 from lib389.utils import *
 from lib389.mit_krb5 import MitKrb5
 
-
 #########################################
 #
 # WARNING!!!!! If this test is failing, and your here to find out why, the
@@ -34,94 +41,33 @@ REALM = "EXAMPLE.COM"
 HOST_MASTER_1 = 'ldapkdc1.example.com'
 HOST_MASTER_2 = 'ldapkdc2.example.com'
 
-class TopologyReplication(object):
-    def __init__(self, master1, master2):
-        master1.open()
-        self.master1 = master1
-        master2.open()
-        self.master2 = master2
-
-
-@pytest.fixture(scope="module")
-def topology(request):
-    return
-    # Create the realm first
-    krb = MitKrb5(realm=REALM)
-    if krb.check_realm():
-        krb.destroy_realm()
-    krb.create_realm()
-    DEBUG = False
-
-    # Creating master 1...
-    master1 = DirSrv(verbose=DEBUG)
-    args_instance[SER_HOST] = HOST_MASTER_1
-    args_instance[SER_PORT] = PORT_MASTER_1
-    args_instance[SER_SERVERID_PROP] = SERVERID_MASTER_1
-    args_instance[SER_CREATION_SUFFIX] = DEFAULT_SUFFIX
-    args_instance[SER_REALM] = REALM
-    args_instance[SER_STRICT_HOSTNAME_CHECKING] = False
-    args_master = args_instance.copy()
-    master1.allocate(args_master)
-    instance_master1 = master1.exists()
-    if instance_master1:
-        master1.delete()
-    master1.create() # There is some magic in .create that finds the realm, and adds the keytab for us.
-    master1.open()
-    master1.replica.enableReplication(suffix=SUFFIX, role=REPLICAROLE_MASTER, replicaId=REPLICAID_MASTER_1)
-
-    # Creating master 2...
-    master2 = DirSrv(verbose=DEBUG)
-    args_instance[SER_HOST] = HOST_MASTER_2
-    args_instance[SER_PORT] = PORT_MASTER_2
-    args_instance[SER_SERVERID_PROP] = SERVERID_MASTER_2
-    args_instance[SER_CREATION_SUFFIX] = DEFAULT_SUFFIX
-    args_instance[SER_REALM] = REALM
-    args_instance[SER_STRICT_HOSTNAME_CHECKING] = False
-    args_master = args_instance.copy()
-    master2.allocate(args_master)
-    instance_master2 = master2.exists()
-    if instance_master2:
-        master2.delete()
-    master2.create()
-    master2.open()
-    master2.replica.enableReplication(suffix=SUFFIX, role=REPLICAROLE_MASTER, replicaId=REPLICAID_MASTER_2)
-
-    # Delete each instance in the end
-    def fin():
-        master1.delete()
-        master2.delete()
-        if krb.check_realm():
-            krb.destroy_realm()
-    request.addfinalizer(fin)
-
-    # Clear out the tmp dir
-    master1.clearTmpDir(__file__)
-
-    return TopologyReplication(master1, master2)
 
 def _create_machine_ou(inst):
-    inst.add_s( Entry(( "ou=Machines,%s" % DEFAULT_SUFFIX, {
-            'objectClass' : 'top organizationalUnit'.split(),
-            'ou' : 'Machines'
-        }
-        ))
-    )
+    inst.add_s(Entry(("ou=Machines,%s" % DEFAULT_SUFFIX, {
+        'objectClass': 'top organizationalUnit'.split(),
+        'ou': 'Machines'
+    }
+                      ))
+               )
+
 
 def _create_machine_account(inst, name):
     # Create the simple security objects for the servers to replicate to
-    inst.add_s( Entry(( "uid=%s,ou=Machines,%s" % (name, DEFAULT_SUFFIX),
-        {
-            'objectClass' : 'top account'.split(),
-            'uid' : name
-        }
-        )))
+    inst.add_s(Entry(("uid=%s,ou=Machines,%s" % (name, DEFAULT_SUFFIX),
+                      {
+                          'objectClass': 'top account'.split(),
+                          'uid': name
+                      }
+                      )))
+
 
 def _check_machine_account(inst, name):
-    r = inst.search_s( 'ou=Machines,%s' % DEFAULT_SUFFIX, ldap.SCOPE_SUBTREE, '(uid=%s)' % name)
+    r = inst.search_s('ou=Machines,%s' % DEFAULT_SUFFIX, ldap.SCOPE_SUBTREE, '(uid=%s)' % name)
     if len(r) > 0:
         return True
     return False
 
+
 def _allow_machine_account(inst, name):
     # First we need to get the mapping tree dn
     mt = inst.mappingtree.list(suffix=DEFAULT_SUFFIX)[0]
@@ -129,15 +75,15 @@ def _allow_machine_account(inst, name):
         (ldap.MOD_REPLACE, 'nsDS5ReplicaBindDN', "uid=%s,ou=Machines,%s" % (name, DEFAULT_SUFFIX))
     ])
 
-def test_gssapi_repl(topology):
-    """
-    Create a kdc, then using that, provision two masters which have a gssapi
+
+def test_gssapi_repl(topology_m2):
+    """Create a kdc, then using that, provision two masters which have a gssapi
     authenticated replication agreement.
     """
-    return
-    master1 = topology.master1
-    master2 = topology.master2
 
+    return
+    master1 = topology_m2.ms["master1"]
+    master2 = topology_m2.ms["master2"]
 
     # Create the locations on each master for the other to bind to.
     _create_machine_ou(master1)
@@ -158,8 +104,8 @@ def test_gssapi_repl(topology):
     # Creating agreement from master 1 to master 2
 
     # Set the replica bind method to sasl gssapi
-    properties = {RA_NAME:      r'meTo_$host:$port',
-                  RA_METHOD:    'SASL/GSSAPI',
+    properties = {RA_NAME: r'meTo_$host:$port',
+                  RA_METHOD: 'SASL/GSSAPI',
                   RA_TRANSPORT_PROT: defaultProperties[REPLICATION_TRANSPORT]}
     m1_m2_agmt = master1.agreement.create(suffix=SUFFIX, host=master2.host, port=master2.port, properties=properties)
     if not m1_m2_agmt:
@@ -170,8 +116,8 @@ def test_gssapi_repl(topology):
     # Creating agreement from master 2 to master 1
 
     # Set the replica bind method to sasl gssapi
-    properties = {RA_NAME:      r'meTo_$host:$port',
-                  RA_METHOD:    'SASL/GSSAPI',
+    properties = {RA_NAME: r'meTo_$host:$port',
+                  RA_METHOD: 'SASL/GSSAPI',
                   RA_TRANSPORT_PROT: defaultProperties[REPLICATION_TRANSPORT]}
     m2_m1_agmt = master2.agreement.create(suffix=SUFFIX, host=master1.host, port=master1.port, properties=properties)
     if not m2_m1_agmt:
@@ -199,15 +145,12 @@ def test_gssapi_repl(topology):
     _create_machine_account(master1, 'http/one.example.com')
     # Check it's on 2
     time.sleep(5)
-    assert(_check_machine_account(master2, 'http/one.example.com'))
+    assert (_check_machine_account(master2, 'http/one.example.com'))
     # Add a user to master 2
     _create_machine_account(master2, 'http/two.example.com')
     # Check it's on 1
     time.sleep(5)
-    assert(_check_machine_account(master2, 'http/two.example.com'))
-
-
-    log.info('Test complete')
+    assert (_check_machine_account(master2, 'http/two.example.com'))
 
 
 if __name__ == '__main__':
diff --git a/dirsrvtests/tests/suites/memberof_plugin/memberof_test.py b/dirsrvtests/tests/suites/memberof_plugin/memberof_test.py
index 2123a7c..7b82ca7 100644
--- a/dirsrvtests/tests/suites/memberof_plugin/memberof_test.py
+++ b/dirsrvtests/tests/suites/memberof_plugin/memberof_test.py
@@ -1,12 +1,11 @@
 # --- BEGIN COPYRIGHT BLOCK ---
-# Copyright (C) 2015 Red Hat, Inc.
+# Copyright (C) 2016 Red Hat, Inc.
 # All rights reserved.
 #
 # License: GPL (version 3 or any later version).
 # See LICENSE for details.
 # --- END COPYRIGHT BLOCK ---
 #
-
 import os
 import sys
 import time
@@ -22,7 +21,6 @@ from lib389.utils import *
 
 logging.getLogger(__name__).setLevel(logging.DEBUG)
 log = logging.getLogger(__name__)
-installation1_prefix = None
 
 MEMBEROF_PLUGIN_DN = ('cn=' + PLUGIN_MEMBER_OF + ',cn=plugins,cn=config')
 USER1_DN = 'uid=user1,' + DEFAULT_SUFFIX
@@ -30,69 +28,31 @@ USER2_DN = 'uid=user2,' + DEFAULT_SUFFIX
 GROUP_DN = 'cn=group,' + DEFAULT_SUFFIX
 
 
-class TopologyStandalone(object):
-    def __init__(self, standalone):
-        standalone.open()
-        self.standalone = standalone
-
-
-@pytest.fixture(scope="module")
-def topology(request):
-    global installation1_prefix
-    if installation1_prefix:
-        args_instance[SER_DEPLOYED_DIR] = installation1_prefix
-
-    # Creating standalone instance ...
-    standalone = DirSrv(verbose=False)
-    args_instance[SER_HOST] = HOST_STANDALONE
-    args_instance[SER_PORT] = PORT_STANDALONE
-    args_instance[SER_SERVERID_PROP] = SERVERID_STANDALONE
-    args_instance[SER_CREATION_SUFFIX] = DEFAULT_SUFFIX
-    args_standalone = args_instance.copy()
-    standalone.allocate(args_standalone)
-    instance_standalone = standalone.exists()
-    if instance_standalone:
-        standalone.delete()
-    standalone.create()
-    standalone.open()
-
-    # Delete each instance in the end
-    def fin():
-        standalone.delete()
-    request.addfinalizer(fin)
-
-    # Clear out the tmp dir
-    standalone.clearTmpDir(__file__)
-
-    return TopologyStandalone(standalone)
-
-
-def test_memberof_auto_add_oc(topology):
-    """
-    Test the auto add objectclass feature.  The plugin should add a predefined
+def test_memberof_auto_add_oc(topology_st):
+    """Test the auto add objectclass feature.  The plugin should add a predefined
     objectclass that will allow memberOf to be added to an entry.
     """
 
     # enable dynamic plugins
     try:
-        topology.standalone.modify_s(DN_CONFIG,
-                                     [(ldap.MOD_REPLACE,
-                                       'nsslapd-dynamic-plugins',
-                                       'on')])
+        topology_st.standalone.modify_s(DN_CONFIG,
+                                        [(ldap.MOD_REPLACE,
+                                          'nsslapd-dynamic-plugins',
+                                          'on')])
     except ldap.LDAPError as e:
         ldap.error('Failed to enable dynamic plugins! ' + e.message['desc'])
         assert False
 
     # Enable the plugin
-    topology.standalone.plugins.enable(name=PLUGIN_MEMBER_OF)
+    topology_st.standalone.plugins.enable(name=PLUGIN_MEMBER_OF)
 
     # First test invalid value (config validation)
-    topology.standalone.plugins.enable(name=PLUGIN_MEMBER_OF)
+    topology_st.standalone.plugins.enable(name=PLUGIN_MEMBER_OF)
     try:
-        topology.standalone.modify_s(MEMBEROF_PLUGIN_DN,
-                                     [(ldap.MOD_REPLACE,
-                                       'memberofAutoAddOC',
-                                       'invalid123')])
+        topology_st.standalone.modify_s(MEMBEROF_PLUGIN_DN,
+                                        [(ldap.MOD_REPLACE,
+                                          'memberofAutoAddOC',
+                                          'invalid123')])
         log.fatal('Incorrectly added invalid objectclass!')
         assert False
     except ldap.UNWILLING_TO_PERFORM:
@@ -102,65 +62,65 @@ def test_memberof_auto_add_oc(topology):
         assert False
 
     # Add valid objectclass
-    topology.standalone.plugins.enable(name=PLUGIN_MEMBER_OF)
+    topology_st.standalone.plugins.enable(name=PLUGIN_MEMBER_OF)
     try:
-        topology.standalone.modify_s(MEMBEROF_PLUGIN_DN,
-                                     [(ldap.MOD_REPLACE,
-                                       'memberofAutoAddOC',
-                                       'inetuser')])
+        topology_st.standalone.modify_s(MEMBEROF_PLUGIN_DN,
+                                        [(ldap.MOD_REPLACE,
+                                          'memberofAutoAddOC',
+                                          'inetuser')])
     except ldap.LDAPError as e:
         log.fatal('Failed to configure memberOf plugin: error ' + e.message['desc'])
         assert False
 
     # Add two users
     try:
-        topology.standalone.add_s(Entry((USER1_DN,
-                                         {'objectclass': 'top',
-                                          'objectclass': 'person',
-                                          'objectclass': 'organizationalPerson',
-                                          'objectclass': 'inetorgperson',
-                                          'sn': 'last',
-                                          'cn': 'full',
-                                          'givenname': 'user1',
-                                          'uid': 'user1'
-                                         })))
+        topology_st.standalone.add_s(Entry((USER1_DN,
+                                            {'objectclass': 'top',
+                                             'objectclass': 'person',
+                                             'objectclass': 'organizationalPerson',
+                                             'objectclass': 'inetorgperson',
+                                             'sn': 'last',
+                                             'cn': 'full',
+                                             'givenname': 'user1',
+                                             'uid': 'user1'
+                                             })))
     except ldap.LDAPError as e:
         log.fatal('Failed to add user1 entry, error: ' + e.message['desc'])
         assert False
 
     try:
-        topology.standalone.add_s(Entry((USER2_DN,
-                                         {'objectclass': 'top',
-                                          'objectclass': 'person',
-                                          'objectclass': 'organizationalPerson',
-                                          'objectclass': 'inetorgperson',
-                                          'sn': 'last',
-                                          'cn': 'full',
-                                          'givenname': 'user2',
-                                          'uid': 'user2'
-                                         })))
+        topology_st.standalone.add_s(Entry((USER2_DN,
+                                            {'objectclass': 'top',
+                                             'objectclass': 'person',
+                                             'objectclass': 'organizationalPerson',
+                                             'objectclass': 'inetorgperson',
+                                             'sn': 'last',
+                                             'cn': 'full',
+                                             'givenname': 'user2',
+                                             'uid': 'user2'
+                                             })))
     except ldap.LDAPError as e:
         log.fatal('Failed to add user2 entry, error: ' + e.message['desc'])
         assert False
 
     # Add a group(that already includes one user
     try:
-        topology.standalone.add_s(Entry((GROUP_DN,
-                                         {'objectclass': 'top',
-                                          'objectclass': 'groupOfNames',
-                                          'cn': 'group',
-                                          'member': USER1_DN
-                                         })))
+        topology_st.standalone.add_s(Entry((GROUP_DN,
+                                            {'objectclass': 'top',
+                                             'objectclass': 'groupOfNames',
+                                             'cn': 'group',
+                                             'member': USER1_DN
+                                             })))
     except ldap.LDAPError as e:
         log.fatal('Failed to add group entry, error: ' + e.message['desc'])
         assert False
 
     # Add a user to the group
     try:
-        topology.standalone.modify_s(GROUP_DN,
-                                     [(ldap.MOD_ADD,
-                                       'member',
-                                       USER2_DN)])
+        topology_st.standalone.modify_s(GROUP_DN,
+                                        [(ldap.MOD_ADD,
+                                          'member',
+                                          USER2_DN)])
     except ldap.LDAPError as e:
         log.fatal('Failed to add user2 to group: error ' + e.message['desc'])
         assert False
@@ -172,4 +132,4 @@ if __name__ == '__main__':
     # Run isolated
     # -s for DEBUG mode
     CURRENT_FILE = os.path.realpath(__file__)
-    pytest.main("-s %s" % CURRENT_FILE)
\ No newline at end of file
+    pytest.main("-s %s" % CURRENT_FILE)
diff --git a/dirsrvtests/tests/suites/memory_leaks/range_search_test.py b/dirsrvtests/tests/suites/memory_leaks/range_search_test.py
index d8d591f..9a81e98 100644
--- a/dirsrvtests/tests/suites/memory_leaks/range_search_test.py
+++ b/dirsrvtests/tests/suites/memory_leaks/range_search_test.py
@@ -1,5 +1,5 @@
 # --- BEGIN COPYRIGHT BLOCK ---
-# Copyright (C) 2015 Red Hat, Inc.
+# Copyright (C) 2016 Red Hat, Inc.
 # All rights reserved.
 #
 # License: GPL (version 3 or any later version).
@@ -22,78 +22,46 @@ from lib389.utils import *
 logging.getLogger(__name__).setLevel(logging.DEBUG)
 log = logging.getLogger(__name__)
 
-installation1_prefix = None
-
-
-class TopologyStandalone(object):
-    def __init__(self, standalone):
-        standalone.open()
-        self.standalone = standalone
-
 
 @pytest.fixture(scope="module")
-def topology(request):
-    global installation1_prefix
-    if installation1_prefix:
-        args_instance[SER_DEPLOYED_DIR] = installation1_prefix
-
-    # Creating standalone instance ...
-    standalone = DirSrv(verbose=False)
-    args_instance[SER_HOST] = HOST_STANDALONE
-    args_instance[SER_PORT] = PORT_STANDALONE
-    args_instance[SER_SERVERID_PROP] = SERVERID_STANDALONE
-    args_instance[SER_CREATION_SUFFIX] = DEFAULT_SUFFIX
-    args_standalone = args_instance.copy()
-    standalone.allocate(args_standalone)
-    instance_standalone = standalone.exists()
-    if instance_standalone:
-        standalone.delete()
-    standalone.create()
-    standalone.open()
-
-    # Clear out the tmp dir
-    standalone.clearTmpDir(__file__)
-
-    def fin():
-        standalone.delete()
-        if not standalone.has_asan():
-            sbin_dir = standalone.get_sbin_dir()
-            valgrind_disable(sbin_dir)
-    request.addfinalizer(fin)
-
-    return TopologyStandalone(standalone)
-
-
-def test_range_search_init(topology):
-    '''
-    Enable retro cl, and valgrind.  Since valgrind tests move the ns-slapd binary
+def setup(topology_st, request):
+    """Enable retro cl, and valgrind.  Since valgrind tests move the ns-slapd binary
     around it's important to always "valgrind_disable" before "assert False"ing,
     otherwise we leave the wrong ns-slapd in place if there is a failure
-    '''
+    """
 
     log.info('Initializing test_range_search...')
 
-    topology.standalone.plugins.enable(name=PLUGIN_RETRO_CHANGELOG)
+    topology_st.standalone.plugins.enable(name=PLUGIN_RETRO_CHANGELOG)
 
     # First stop the instance
-    topology.standalone.stop(timeout=30)
+    topology_st.standalone.stop(timeout=30)
 
     # Get the sbin directory so we know where to replace 'ns-slapd'
-    sbin_dir = get_sbin_dir(prefix=topology.standalone.prefix)
+    sbin_dir = get_sbin_dir(prefix=topology_st.standalone.prefix)
 
     # Enable valgrind
-    if not topology.standalone.has_asan():
+    if not topology_st.standalone.has_asan():
         valgrind_enable(sbin_dir)
 
+    def fin():
+        if not topology_st.standalone.has_asan():
+            topology_st.standalone.stop(timeout=30)
+            sbin_dir = topology_st.standalone.get_sbin_dir()
+            valgrind_disable(sbin_dir)
+            topology_st.standalone.start()
+
+    request.addfinalizer(fin)
+
     # Now start the server with a longer timeout
-    topology.standalone.start()
+    topology_st.standalone.start()
 
 
-def test_range_search(topology):
-    '''
-    Add a 100 entries, and run a range search.  When we encounter an error we
-    still need to disable valgrind before exiting
-    '''
+def test_range_search(topology_st, setup):
+    """Add a 100 entries, and run a range search.
+    When we encounter an error we still need to
+    disable valgrind before exiting
+    """
 
     log.info('Running test_range_search...')
 
@@ -104,37 +72,34 @@ def test_range_search(topology):
         idx = str(idx)
         USER_DN = 'uid=user' + idx + ',' + DEFAULT_SUFFIX
         try:
-            topology.standalone.add_s(Entry((USER_DN, {'objectclass': "top extensibleObject".split(),
-                                 'uid': 'user' + idx})))
+            topology_st.standalone.add_s(Entry((USER_DN, {'objectclass': "top extensibleObject".split(),
+                                                          'uid': 'user' + idx})))
         except ldap.LDAPError as e:
             log.fatal('test_range_search: Failed to add test user ' + USER_DN + ': error ' + e.message['desc'])
             success = False
     time.sleep(1)
 
+    # Issue range search
     if success:
-        # Issue range search
         try:
-            topology.standalone.search_s(RETROCL_SUFFIX, ldap.SCOPE_SUBTREE,
-                                         '(&(changenumber>=74)(changenumber<=84))')
+            topology_st.standalone.search_s(RETROCL_SUFFIX, ldap.SCOPE_SUBTREE,
+                                            '(&(changenumber>=74)(changenumber<=84))')
         except ldap.LDAPError as e:
             log.fatal('test_range_search: Failed to search retro changelog(%s), error: %s' %
                       (RETROCL_SUFFIX, e.message('desc')))
             success = False
 
-    if success and not topology.standalone.has_asan():
+    if success and not topology_st.standalone.has_asan():
         # Get the results file, stop the server, and check for the leak
-        results_file = valgrind_get_results_file(topology.standalone)
-        topology.standalone.stop(timeout=30)
+        results_file = valgrind_get_results_file(topology_st.standalone)
+        topology_st.standalone.stop(timeout=30)
         if valgrind_check_file(results_file, VALGRIND_LEAK_STR, 'range_candidates'):
             log.fatal('test_range_search: Memory leak is still present!')
             assert False
 
-    log.info('test_range_search: PASSED')
-
 
 if __name__ == '__main__':
     # Run isolated
     # -s for DEBUG mode
     CURRENT_FILE = os.path.realpath(__file__)
     pytest.main("-s %s" % CURRENT_FILE)
-
